﻿#pragma strict 
#pragma downcast
//#pragma strict = forces typing for all variables.
//#pragma downcast = suppresses errors when general things (like hashtable elements) get used in specific ways.

import UnityEngine.UI; 

//indexes (for certain parts of the hash variables).  
var contentIndex:int; //where we are right now.
var firstIndex:int; //first possible hash index.
var lastIndex:int; //last possible hash index.
//hash variables (sets of related data).
var contentTextHash:Hashtable; //text for main text field.
var titleTextHash:Hashtable; //text for titles.
var showContentHash:Hashtable; //true/false for whether or not we want the main text.
//reference to our main background & text (child).
var contentBackground:GameObject;

function Start () {
	firstIndex = 1;
	contentIndex = firstIndex;
	contentTextHash = new Hashtable(); 
	titleTextHash = new Hashtable(); 
	showContentHash = new Hashtable(); 
	contentBackground = GameObject.FindWithTag("contentBackground"); 
	
	contentTextHash.Add(1, "The lunar phase or phase of the moon is the shape of the illuminated (sunlit) portion of the Moon as seen by an observer, usually on Earth. The lunar phases change cyclically as the Moon orbits the Earth, according to the changing relative positions of the Earth, Moon, and Sun. The moon and the Earth are tidally locked, and therefore the same lunar surface always faces Earth. This face is variously sunlit depending on the position of the moon in its orbit. Therefore, the portion of this hemisphere that is visible to an observer on Earth can vary from about 100% (full moon) to 0% (new moon). The lunar terminator is the boundary between the illuminated and darkened hemispheres. Aside from some craters near the lunar poles such as Shoemaker, all parts of the Moon see around 14.77 days of sunlight followed by 14.77 days of 'night' (the 'dark side' of the Moon is a reference to radio darkness, not visible light darkness\n\nThe four principal lunar phases are first quarter, full moon, third quarter, and new moon (third quarter moon is also known as last quarter moon.) Each of the four lunar phases is roughly 7 days (~7.4 days) each, but varies slightly due to lunar apogee and perigee.\n\nThese are the instants when, respectively, the Moon's apparent geocentric celestial longitude minus the Sun's apparent geocentric celestial longitude is 0°, 90°, 180° and 270°.\n\nWhen the Sun and Moon are aligned on the same side of the Earth the Moon is 'new', and the side of the Moon visible from Earth is not illuminated by the Sun. As the Moon waxes (the amount of illuminated surface as seen from Earth is increasing), the lunar phases progress from new moon, crescent moon, first-quarter moon, gibbous moon and full moon phases, before returning through the gibbous moon, third-quarter moon, crescent moon and new moon phases. The terms old moon and new moon are interchangeable, although new moon is more common. Half moon is often used to mean the first- and third-quarter moons, while the term 'quarter' refers to the extent of the moon's cycle around the Earth, not its shape.\n\nWhen a sphere is illuminated on one hemisphere and viewed from a different angle, the portion of the illuminated area that is visible will have a two-dimensional shape defined by the intersection of an ellipse and circle (where the major axis of the ellipse coincides with a diameter of the circle). If the half-ellipse is convex with respect to the half-circle, then the shape will be gibbous (bulging outwards, Origin: 1350–1400; Middle English < Latin gibbōsus humped, equivalent to gibb ( a ) hump + -ōsus -ous[1] ), whereas if the half-ellipse is concave with respect to the half-circle, then the shape will be a crescent. When a crescent Moon occurs, the phenomenon of Earthshine may be apparent, where the night side of the Moon faintly reflects light from the Earth.");
	titleTextHash.Add(1, "Lunar Phase");
	showContentHash.Add(1, true);
	
	contentTextHash.Add(2, "The average calendrical month, which is 1⁄12 of a year, is about 30.44 days, while the Moon's phase (synodic) cycle repeats on average every 29.53 days. Therefore the timing of the Moon's phases shifts by an average of almost one day for each successive month. Photographing the Moon's phase every day for a month, starting in the evening after sunset, and repeating approximately 25 minutes later each successive day, ending in the morning before sunrise, would create a composite image like the example calendar from May 8, 2005, to June 6, 2005. There is no picture on May 20 since a picture would be taken before midnight on May 19, and after midnight on May 21. Similarly, on a calendar listing moon rise or set times, some days will appear to be skipped. When the Moon rises just before midnight one night it will rise just after midnight the next (so too with setting). The 'skipped day' is just a calendar artifact and not the Moon behaving strangely. The moon has a predictable orbit every month.");
	titleTextHash.Add(2, "The Calendar");
	showContentHash.Add(2, true);
	
	contentTextHash.Add(3, "");
	titleTextHash.Add(3, "Phases Visual");
	showContentHash.Add(3, false);
	
	contentTextHash.Add(4, "The approximate age of the moon, and hence the approximate phase, can be calculated for any date by calculating the number of days since a known new moon (such as January 1, 1900 or August 11, 1999) and reducing this modulo 29.530588853 (the length of a synodic month). The difference between two dates can be calculated by subtracting the Julian Day Number of one from that of the other, or there are simpler formulae giving (for instance) the number of days since December 31, 1899. However, this calculation assumes a perfectly circular orbit and therefore may be incorrect by several hours (it also becomes less accurate the larger the difference between the required date and the reference date); it is accurate enough to use in a novelty clock application showing moon phase, but specialist usage taking account of lunar apogee and perigee requires a more elaborate calculation.");
	titleTextHash.Add(4, "Calculating Phase");
	showContentHash.Add(4, true);
	
	contentTextHash.Add(5, "The Earth subtends an angle of about two degrees, when seen from the Moon. This means that an observer on Earth who sees the Moon when it is close to the eastern horizon sees it from an angle that is about two degrees different from the line of sight of an observer who sees the Moon on the western horizon. The Moon moves about 12 degrees around its orbit per day, so, if these observers were stationary, they would see the phases of the Moon at times that differ by about one-sixth of a day, or four hours. But in reality the observers are on the surface of the rotating Earth, so someone who sees the Moon on the eastern horizon at one moment sees it on the western horizon about 12 hours later. This adds an oscillation to the apparent progression of the lunar phases. They appear to occur more slowly when the Moon is high in the sky than when it is below the horizon. The Moon appears to move jerkily, and the phases do the same. The amplitude of this oscillation is never more than about four hours, which is a small fraction of a month. It does not have any obvious effect on the appearance of the Moon. However, it does affect accurate calculations of the times of lunar phases.");
	titleTextHash.Add(5, "Effect of Parallax");
	showContentHash.Add(5, true);
	
	contentTextHash.Add(6, "It might be expected that once every month, when the Moon passes between Earth and the Sun during a new moon, its shadow would fall on Earth causing a solar eclipse, but this does not happen every month. Nor is it true that during every full moon, the Earth's shadow falls on the Moon, causing a lunar eclipse. Solar and lunar eclipses are not observed every month because the plane of the Moon's orbit around the Earth is tilted by about five degrees with respect to the plane of Earth's orbit around the Sun (the plane of the ecliptic). Thus, when new and full moons occur, the Moon usually lies to the north or south of a direct line through the Earth and Sun. Although an eclipse can only occur when the Moon is either new (solar) or full (lunar), it must also be positioned very near the intersection of Earth's orbit plane about the Sun and the Moon's orbit plane about the Earth (that is, at one of its nodes). This happens about twice per year, and so there are between four and seven eclipses in a calendar year. Most of these events are quite insignificant; major eclipses of the Moon or Sun are less frequent.");
	titleTextHash.Add(6, "Misconceptions");
	showContentHash.Add(6, true);
	
	if(titleTextHash.Count != contentTextHash.Count) {
		Debug.Log("Warning: Title and Content are of a different length, this will break the navigation");
	}
	if (titleTextHash.Count != showContentHash.Count) {
		Debug.Log("Warning: Title and Show Content are of a different length, this will break the navigation");
	}
	
	gotoAndStop(firstIndex);
	lastIndex = titleTextHash.Count;
}

//go to and stop at a provided hash number (which requires updating everything), then update the index of where we are.  
function gotoAndStop(newHash:int) {

}

//go to the next hash of content.
function nextContent() {

}

//go to the previous hash of content.
function previousContent() {

}

//make the text and background disappear when we show the visual.
//make it come back when we are not showing the visual.
//hint:  SetActive() is a handy function.  
function updateGUI(hideShow:boolean) {
	
}

//update the main text field with the relevant hash.
function updateContent(newContent:String) {
	
}

//update the title text field with the relevant hash.
function updateTitle(newTitle:String) { 
    GameObject.FindWithTag("titleText").GetComponent(Text).text = newTitle;
}

function Update () {

}